- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# fm::tree< KEY, DATA >::const_iterator Class Reference

A tree constant-element iterator. More...

`#include <FMTree.h>`

List of all members.

## Public Member Functions
| const_iterator ()
| Empty constructor.
| const_iterator (const iterator &copy)
| Copy constructor.
| const_iterator (const node *n)
| Constructor.
const_iterator & | operator= (const iterator &copy)
| Copy operator.
const_iterator & | operator= (const const_iterator &copy)
| See above.
bool | operator== (const iterator &other) const
| Retrieves whether this iterator points to the same node as the given iterator.
bool | operator== (const const_iterator &other) const
| See above.
bool | operator!= (const iterator &other) const
| Retrieves whether this iterator points to a different node that a given iterator.
bool | operator!= (const const_iterator &other) const
| See above.
const_iterator & | operator++ ()
| Advances the iterator to the next ordered tree node.
const_iterator & | operator-- ()
| Backtrack the iterator to the next ordered tree node.
const pair & | operator * ()
| Retrieves the current tree node.
const pair * | operator-> ()
| See above.
## Friends
class | tree
class | iterator

## Detailed Description

### template<class KEY, class DATA>
class fm::tree< KEY, DATA >::const_iterator

A tree constant-element iterator.

Similar to the basic STL const_iterator.

## Constructor & Destructor Documentation

template<class KEY, class DATA>
fm::tree< KEY, DATA >::const_iterator::const_iterator | ( | const iterator & | copy | ) | `[inline]`

  | Copy constructor. Parameters:
  | copy | The iterator to clone.

template<class KEY, class DATA>
fm::tree< KEY, DATA >::const_iterator::const_iterator | ( | const node * | n | ) | `[inline]`

  | Constructor. Parameters:
  | n | The tree node at which to start the iteration.

## Member Function Documentation

template<class KEY, class DATA>
const pair& fm::tree< KEY, DATA >::const_iterator::operator * | ( |  | ) | `[inline]`

| Retrieves the current tree node. Returns: The current tree node.

template<class KEY, class DATA>
bool fm::tree< KEY, DATA >::const_iterator::operator!= | ( | const iterator & | other | ) | const`[inline]`

  | Retrieves whether this iterator points to a different node that a given iterator. Parameters:
  | other | A second iterator.
Returns: Whether the two iterators are pointing at different nodes.

template<class KEY, class DATA>
const_iterator& fm::tree< KEY, DATA >::const_iterator::operator++ | ( |  | ) | `[inline]`

| Advances the iterator to the next ordered tree node. Returns: This iterator.

template<class KEY, class DATA>
const_iterator& fm::tree< KEY, DATA >::const_iterator::operator-- | ( |  | ) | `[inline]`

| Backtrack the iterator to the next ordered tree node. Returns: This iterator.

template<class KEY, class DATA>
const_iterator& fm::tree< KEY, DATA >::const_iterator::operator= | ( | const iterator & | copy | ) | `[inline]`

  | Copy operator. Parameters:
  | copy | The tree iterator to copy.

template<class KEY, class DATA>
bool fm::tree< KEY, DATA >::const_iterator::operator== | ( | const iterator & | other | ) | const`[inline]`

  | Retrieves whether this iterator points to the same node as the given iterator. Parameters:
  | other | A second iterator.
Returns: Whether the two iterators are pointing to the same node.

The documentation for this class was generated from the following file:

- FMath/FMTree.h